<?php declare(strict_types=1);

namespace MyPrayerJournal;

use JsonSerializable;

/**
 * The recurrence for a prayer request
 */
class Recurrence implements JsonSerializable
{
    /**
     * @param RecurrencePeriod $period The recurrence period
     * @param int|null $interval How many of the periods will pass before the request is visible again
     */
    public function __construct(public RecurrencePeriod $period, public ?int $interval = null) { }

    public function jsonSerialize(): mixed
    {
        $values = ['period' => $this->period->value];
        if (!is_null($this->interval)) $values['interval'] = $this->interval;
        return $values;
    }
}
